Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.jxpath.ri.model.beans
Class PropertyPointer

    java.lang.Object
      org.apache.commons.jxpath.ri.model.NodePointer
          org.apache.commons.jxpath.ri.model.beans.PropertyPointer

All Implemented Interfaces:
  Serializable, Cloneable, Comparable, Pointer

Direct Known Subclasses:
  BeanPropertyPointer, DynaBeanPropertyPointer, DynamicPropertyPointer, NullPropertyPointer

    public abstract class PropertyPointer

extends NodePointer

A pointer allocated by a PropertyOwnerPointer to represent the value of a property of the parent object.

Version:
  $Revision: 652845 $ $Date: 2008-05-02 12:46:46 -0500 (Fri, 02 May 2008) $
Author:
  Dmitri Plotnikov
See Also:
  Serialized Form

Field Summary
`protected Object` | `bean` owning object
`protected int` | `propertyIndex` property index
`static int` | `UNSPECIFIED_PROPERTY`

Fields inherited from class org.apache.commons.jxpath.ri.model.NodePointer
`index, locale, parent, UNKNOWN_NAMESPACE, WHOLE_COLLECTION`

Constructor Summary
`PropertyPointer(NodePointer parent)` Takes a javabean, a descriptor of a property of that object and an offset within that property (starting with 0).

Method Summary
`int` | `compareChildNodePointers(NodePointer pointer1, NodePointer pointer2)` Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.
`NodePointer` | `createChild(JXPathContext context, QName name, int index)` Called by a child pointer when it needs to create a parent object for a non-existent collection element.
`NodePointer` | `createChild(JXPathContext context, QName name, int index, Object value)` Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node.
`NodePointer` | `createPath(JXPathContext context)` Called by a child pointer when it needs to create a parent object.
`NodePointer` | `createPath(JXPathContext context, Object value)` Called directly by JXPathContext.
`boolean` | `equals(Object object)`
`Object` | `getBean()` Get the parent bean.
`Object` | `getImmediateNode()` Returns the object the pointer points to; does not convert it to a "canonical" type.
`NodePointer` | `getImmediateValuePointer()` Returns a NodePointer that can be used to access the currently selected property value.
`int` | `getLength()` If the property contains a collection, then the length of that collection, otherwise - 1.
`QName` | `getName()` Returns the name of this node.
`abstract int` | `getPropertyCount()` Count the number of properties represented.
`int` | `getPropertyIndex()` Get the property index.
`abstract String` | `getPropertyName()` Get the property name.
`abstract String[]` | `getPropertyNames()` Get the names of the included properties.
`int` | `hashCode()`
`boolean` | `isActual()` An actual pointer points to an existing part of an object graph, even if it is null.
`protected abstract boolean` | `isActualProperty()` Learn whether this pointer references an actual property.
`boolean` | `isCollection()` Returns `true` if the value of the pointer is an array or a Collection.
`boolean` | `isLeaf()` If true, this node does not have children
`void` | `setPropertyIndex(int index)` Set the property index.
`abstract void` | `setPropertyName(String propertyName)` Set the property name.

Methods inherited from class org.apache.commons.jxpath.ri.model.NodePointer
`asPath, attributeIterator, childIterator, clone, compareTo, createAttribute, escape, getAbstractFactory, getBaseValue, getDefaultNamespaceURI, getImmediateParentPointer, getIndex, getLocale, getNamespaceResolver, getNamespaceURI, getNamespaceURI, getNode, getNodeSetByKey, getNodeValue, getParent, getPointerByID, getPointerByKey, getRootNode, getValue, getValuePointer, isAttribute, isContainer, isDefaultNamespace, isLanguage, isNode, isRoot, namespaceIterator, namespacePointer, newChildNodePointer, newNodePointer, printPointerChain, remove, setAttribute, setIndex, setNamespaceResolver, setValue, testNode, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### UNSPECIFIED_PROPERTY

    public static final int UNSPECIFIED_PROPERTY

See Also:
  Constant Field Values

### propertyIndex

    protected int propertyIndex

  property index

### bean

    protected Object bean

  owning object

Constructor Detail

### PropertyPointer

    public PropertyPointer(NodePointer parent)

  Takes a javabean, a descriptor of a property of that object and an offset within that property (starting with 0).

  Parameters:
    `parent` - parent pointer

Method Detail

### getPropertyIndex

    public int getPropertyIndex()

  Get the property index.

  Returns:
    int index

### setPropertyIndex

    public void setPropertyIndex(int index)

  Set the property index.

  Parameters:
    `index` - property index

### getBean

    public Object getBean()

  Get the parent bean.

  Returns:
    Object

### getName

    public QName getName()

  Description copied from class: `NodePointer`
  Returns the name of this node. Can be null.

  Specified by:
    `getName` in class `NodePointer`
  Returns:
    QName

### getPropertyName

    public abstract String getPropertyName()

  Get the property name.

  Returns:
    String property name.

### setPropertyName

    public abstract void setPropertyName(String propertyName)

  Set the property name.

  Parameters:
    `propertyName` - property name to set.

### getPropertyCount

    public abstract int getPropertyCount()

  Count the number of properties represented.

  Returns:
    int

### getPropertyNames

    public abstract String[] getPropertyNames()

  Get the names of the included properties.

  Returns:
    String[]

### isActualProperty

    protected abstract boolean isActualProperty()

  Learn whether this pointer references an actual property.

  Returns:
    true if actual

### isActual

    public boolean isActual()

  Description copied from class: `NodePointer`
  An actual pointer points to an existing part of an object graph, even if it is null. A non-actual pointer represents a part that does not exist at all. For instance consider the pointer "/address/street". If both address and street are not null, the pointer is actual. If address is not null, but street is null, the pointer is still actual. If address is null, the pointer is not actual. (In JavaBeans) if address is not a property of the root bean, a Pointer for this path cannot be obtained at all - actual or otherwise.

  Overrides:
    `isActual` in class `NodePointer`
  Returns:
    boolean

### getImmediateNode

    public Object getImmediateNode()

  Description copied from class: `NodePointer`
  Returns the object the pointer points to; does not convert it to a "canonical" type.

  Specified by:
    `getImmediateNode` in class `NodePointer`
  Returns:
    Object node

### isCollection

    public boolean isCollection()

  Description copied from class: `NodePointer`
  Returns `true` if the value of the pointer is an array or a Collection.

  Specified by:
    `isCollection` in class `NodePointer`
  Returns:
    boolean

### isLeaf

    public boolean isLeaf()

  Description copied from class: `NodePointer`
  If true, this node does not have children

  Specified by:
    `isLeaf` in class `NodePointer`
  Returns:
    boolean

### getLength

    public int getLength()

  If the property contains a collection, then the length of that collection, otherwise - 1.

  Specified by:
    `getLength` in class `NodePointer`
  Returns:
    int length

### getImmediateValuePointer

    public NodePointer getImmediateValuePointer()

  Returns a NodePointer that can be used to access the currently selected property value.

  Overrides:
    `getImmediateValuePointer` in class `NodePointer`
  Returns:
    NodePointer
  See Also:
    `NodePointer.getValuePointer()`

### createPath

    public NodePointer createPath(JXPathContext context)

  Description copied from class: `NodePointer`
  Called by a child pointer when it needs to create a parent object. Must create an object described by this pointer and return a new pointer that properly describes the new object.

  Overrides:
    `createPath` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathContext
  Returns:
    created NodePointer

### createPath

    public NodePointer createPath(JXPathContext context,
                                  Object value)

  Description copied from class: `NodePointer`
  Called directly by JXPathContext. Must create path and set value.

  Overrides:
    `createPath` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathContext
    `value` - the new value to set
  Returns:
    created NodePointer

### createChild

    public NodePointer createChild(JXPathContext context,
                                   QName name,
                                   int index,
                                   Object value)

  Description copied from class: `NodePointer`
  Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node. This method may have to expand the collection in order to assign the element.

  Overrides:
    `createChild` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathCOntext
    `name` - the QName at which a child should be created
    `index` - child index.
    `value` - node value to set
  Returns:
    created NodePointer

### createChild

    public NodePointer createChild(JXPathContext context,
                                   QName name,
                                   int index)

  Description copied from class: `NodePointer`
  Called by a child pointer when it needs to create a parent object for a non-existent collection element. It may have to expand the collection, then create an element object and return a new pointer describing the newly created element.

  Overrides:
    `createChild` in class `NodePointer`
  Parameters:
    `context` - the owning JXPathCOntext
    `name` - the QName at which a child should be created
    `index` - child index.
  Returns:
    created NodePointer

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### equals

    public boolean equals(Object object)

  Overrides:
    `equals` in class `Object`

### compareChildNodePointers

    public int compareChildNodePointers(NodePointer pointer1,
                                        NodePointer pointer2)

  Description copied from class: `NodePointer`
  Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.

  Specified by:
    `compareChildNodePointers` in class `NodePointer`
  Parameters:
    `pointer1` - first pointer to be compared
    `pointer2` - second pointer to be compared
  Returns:
    int per Java comparison conventions

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.